import {
  PropertyKeyType,
} from '@overflow/commons/core/type';

import {Class} from './class';
import {Executable} from './executable';

export class Method extends Executable {
  private _name: PropertyKeyType;
  private _returnType: any;

  public constructor(declaringClazz: Class, name: PropertyKeyType, parameterTypes: any[], returnType: any) {
    super(declaringClazz, parameterTypes);
    this._name = name;
    this._returnType = returnType;
  }

  public getName(): PropertyKeyType {
    return this._name;
  }

  public getReturnType(): any {
    return this._returnType;
  }
}
